from json import JSONEncoder
import json
from datetime import datetime
from iip.TypeTranslatorToString import TypeTranslatorToString
import Registry
from datatypes.Rec13 import Rec13
from datatypes.Rec13Impl import Rec13Impl

class Rec13Encoder(JSONEncoder):
    """JSON encoder class for Rec13.
    Generated by: EASy-Producer."""

    def default(self, o):
        """Provides access to the attributes in o.
        
        Parameters:
          - o -- the object to serialize
        Returns:
          dict
            the attributes
        """
        return o.__dict__
    

class Rec13Serializer(TypeTranslatorToString):
    """JSON transport serializer for Rec13.
       Generated by: EASy-Producer."""
                
    def __init__(self):
        """Initializes the transformer.""" 
        Registry.serializers["Rec13"] = self
        Registry.types[Rec13] = "Rec13"
        Registry.serializers["Rec13Impl"] = self # there is a serializer for the Impl
        Registry.types[Rec13Impl] = "Rec13" # the Impl maps back to the type name
    
    def readFrom(self, data: str) -> Rec13:
        """Turns bytes into a String.
        
        Parameters:
          - data -- the data string
        Returns:
          object
            the deserialized object
        """
    
        result = Rec13Impl()
        result.__dict__ = json.loads(data)
        return result

    def writeTo(self, source: Rec13) -> str:
        """Turns an object into a String.
        
        Parameters:
          - source -- the object
        Returns:
          bytes
            the serialized data string
        """
        
        return Rec13Encoder().encode(source).encode("UTF-8").decode()
        
Rec13Serializer()
